$(document).ready(function() {
		pre_load_audio();
		show_result_pre_loader();
		/**
		 * Static data to be read from page
		 */
		var _active_booking_source = JSON.parse(document.getElementById('pri_active_source').value);
		var _search_id = document.getElementById('pri_search_id').value;
		//var _airline_lg_path = document.getElementById('pri_airline_lg_path').value;
		var _search_params = JSON.parse(document.getElementById('pri_search_params').value);
		var default_currency = 'INR';//document.getElementById('pri_def_curr').value;
		var sliderCurrency = default_currency;
		var application_preference_currency = document.getElementById('pri_preferred_currency').value;

		window.process_result_update = function(result) {
			$('.loader-image').hide();
			if (result.data.hasOwnProperty('quota_list')) {
				$('#j_quota').html(result.data.quota_list);
			}
			if (result.hasOwnProperty('status') == true && result.status == true) {
				$.each(result.data['col_x'], function(k, v) {
					$('#train_search_result #'+k).append(v);
				});
				post_load_audio();
				updateFilters();
				filter_row_origin_marker();
				update_total_count_summary();
				hide_result_pre_loader();
			} else {
				//No Result Found
				console.log('No result found');
				check_empty_search_result();
			}
		};
		function check_empty_search_result()
		{
			if ($('.r-r-i:first').index() == -1) {
				$('#empty-search-result').show();
				$('#page-parent').hide();
			}
		}

		function updateFilters() {
			//update filters
			var temp_minimum_record = $('.r-r-i:first');
			var departureCategoryList = {};
			var arrivalCategoryList = {};
			var minDepartureDatetime = $('.dep_dt:first', temp_minimum_record).data('datetime');
			var maxDepartureDatetime = $('.dep_dt:first', temp_minimum_record).data('datetime');

			var depCat = 0;
			var arrCat = 0;

			$('.r-r-i').each(function(key, value) {
				depCat = parseInt($('.t-d-t:first', this).data('category'));
				arrCat = parseInt($('.t-a-t:first', this).data('category'));
				if (departureCategoryList.hasOwnProperty(depCat) == false) {
					departureCategoryList[depCat] = depCat;
				}
				if (arrivalCategoryList.hasOwnProperty(arrCat) == false) {
					arrivalCategoryList[arrCat] = arrCat;
				}
			});
			loadTimeRangeSelector(departureCategoryList, arrivalCategoryList);
		}
	
		function getArray(objectWrap) {
			var objectWrapValueArr = [];
			$.each(objectWrap, function(key, value) {
				objectWrapValueArr.push(value);
			});
			return objectWrapValueArr;
		}
	
		function getSortedObject(obj) {
			var objValArray = getArray(obj);
			var sortObj = {};
			objValArray.sort();
			$.each(objValArray, function(obj_key, obj_val) {
				$.each(obj, function(i_k, i_v) {
					if (i_v == obj_val) {
						sortObj[i_k] = i_v;
					}
				});
			});
			return sortObj;
		}
		
		//Enable/Disable-Time Range Selector
		function loadTimeRangeSelector(depCatList, arrCatList)
		{
			//Works for both onward and return
			if ($.isPlainObject(depCatList)) {
				var depCatListArray = getArray(depCatList);
				var stopCat = 0;
				$('#departureTimeWrapper .time-category').each(function(key, value) {
					depCat = parseInt($(this).val());
					if (depCatListArray.indexOf(depCat) == -1) {
						//disabled
						$(this).attr('disabled', 'disabled');
						$(this).closest('.time-wrapper').addClass('disabled');
					} else {
						$(this).closest('.time-wrapper').addClass('enabled');
					}
				});
			}
	
			if ($.isPlainObject(arrCatList)) {
				var arrCatListArray = getArray(arrCatList);
				var arrCat = 0;
				$('#arrivalTimeWrapper .time-category').each(function(key, value) {
					arrCat = parseInt($(this).val());
					if (arrCatListArray.indexOf(arrCat) == -1) {
						//disabled
						$(this).attr('disabled', 'disabled');
						$(this).closest('.time-wrapper').addClass('disabled');
					} else {
						$(this).closest('.time-wrapper').addClass('enabled');
					}
				});
			}
		}

		$(document).on('change', '#train-cabin-wrapper .train-cabin, #departureTimeWrapper .time-wrapper.enabled .time-category, #arrivalTimeWrapper .time-wrapper.enabled .time-category', function() {
			filter_row_origin_marker();
		});
	
		function loader(selector) {
			selector = selector || '#train_search_result';
			$(selector).animate({
				'opacity': '.1'
			});
			setTimeout(function() {
				$(selector).animate({
					'opacity': '1'
				}, 'slow');
			}, 1000);
		}
	
		/**
		*Filter function for loaded Row Origin Marker
		*/
		function filter_row_origin_marker() {
			loader();
			visibility = '';
			//get all the search criteria
			var deptimeList = $('.time-category:checked:not(:disabled)', '#departureTimeWrapper').map(function() {
				return parseInt(this.value);
			}).get();
			var arrtimeList = $('.time-category:checked:not(:disabled)', '#arrivalTimeWrapper').map(function() {
				return parseInt(this.value);
			}).get();
			
			var trainCabinList = $('.train-cabin:checked:not(:disabled)', '#train-cabin-wrapper').map(function() {
				return (this.value);
			}).get();
			$('.r-r-i' + visibility).each(function(key, value) {
				var current_cabin = $('.cabin-filter-val', this).val();
				if (((deptimeList.length == 0) || ($.inArray(parseInt($('.t-d-t:first', this).data('category')), deptimeList) != -1)) &&
					((arrtimeList.length == 0) || ($.inArray(parseInt($('.t-a-t:first', this).data('category')), arrtimeList) != -1)) &&
					((trainCabinList.length == 0) || (is_any_cabin_found(trainCabinList, current_cabin)))
				) {
					$(this).show();
				} else {
					$(this).hide();
				}
			});
			update_total_count_summary();
		}
		
		function is_any_cabin_found(filter_cabin, train_cabin)
		{
			var found = false;
			$.each(filter_cabin, function(k, v) {
				if (train_cabin.search(v) != -1) {
					found = true;
					//return false will terminate loop
					return false;
				}
			});
			return found;
		}
	
		/**
		 *Update Hotel Count Details
		 */
		function update_total_count_summary() {
			$('#train_search_result').show();
			var _visible_records = parseInt($('.r-r-i:visible').length);
			var _total_records = $('.r-r-i').length;
			if (isNaN(_visible_records) == true || _visible_records == 0) {
				_visible_records = 0;
				//display warning
				$('#train_search_result').hide();
				$('#empty_train_search_result').show();
			} else {
				$('#train_search_result').show();
				$('#empty_train_search_result').hide();
			}
			$('#total_records').text(_visible_records);
			$('.visible-row-record-count').text(_visible_records);
			$('.total-row-record-count').text(_total_records);
		}
	
		function unique_array_values(array_values) {
			var _unique_array_values = [];
			$.each(array_values, function(k, v) {
				if (_unique_array_values.indexOf(v) == -1) {
					_unique_array_values.push(v);
				}
			});
			return _unique_array_values;
		}
		/**
		* Toggle active class to highlight current applied sorting
		**/
		$(document).on('click', '.sorta', function(e) {
			e.preventDefault();
			$(this).closest('.sortul').find('.active').removeClass('active');
			//Add to sibling
			$(this).siblings().addClass('active');
		});

		$('.loader').on('click', function(e) {
			e.preventDefault();
			loader();
		});
		$(document).on('click', '.reset-page-loader', function(e) {
			e.preventDefault();
			loader();
			location.reload();
		});
	

		$('.toglefil').click(function() {
			$(this).toggleClass('active');
		});
		/** PAGE FUNCTIONALITY ENDS HERE **/
	
		/** TOBIN Wrote this **/
		/*selection and filter fixed- result*/
	if ($('.fixincrmnt').length > 0) {
		var flterffect = $('.fixincrmnt').offset().top;
		$(window).scroll(function() {
			var yPos = $(window).scrollTop();
			if(yPos > flterffect) {
				$('.fixincrmnt, .addtwofilter').addClass('fixed');
			}
			else {
				$('.fixincrmnt, .addtwofilter').removeClass('fixed');
			}
		});
		/*selection fixed- result end*/
	}
	
	//************************** SORTING START **********/
	//name sort
	$("#top-sort-list-1 .name-l-2-h").click(function() {
		$(this).addClass('hide');
		$('#top-sort-list-1 .name-h-2-l').removeClass('hide');
		$("#train_search_result #t-w-i-1").jSort({
			sort_by: '.t-n:first',
			item: '.r-r-i',
			order: 'asc',
			is_num: false
		});
	});
	$("#top-sort-list-1 .name-h-2-l").click(function() {
		$(this).addClass('hide');
		$('#top-sort-list-1 .name-l-2-h').removeClass('hide');
		$("#train_search_result #t-w-i-1").jSort({
			sort_by: '.t-n:first',
			item: '.r-r-i',
			order: 'desc',
			is_num: false
		});
	});
	//duration sort
	$("#top-sort-list-1 .duration-l-2-h").click(function() {
		$(this).addClass('hide');
		$('#top-sort-list-1 .duration-h-2-l').removeClass('hide');
		$("#train_search_result #t-w-i-1").jSort({
			sort_by: '.t-d:first',
			item: '.r-r-i',
			order: 'asc',
			is_num: true
		});
	});
	$("#top-sort-list-1 .duration-h-2-l").click(function() {
		$(this).addClass('hide');
		$('#top-sort-list-1 .duration-l-2-h').removeClass('hide');
		$("#train_search_result #t-w-i-1").jSort({
			sort_by: '.t-d:first',
			item: '.r-r-i',
			order: 'desc',
			is_num: true
		});
	});
	//departure name sort
	$("#top-sort-list-1 .departure-l-2-h").click(function() {
		$(this).addClass('hide');
		$('#top-sort-list-1 .departure-h-2-l').removeClass('hide');
		$("#train_search_result #t-w-i-1").jSort({
			sort_by: '.t-d-t:first',
			item: '.r-r-i',
			order: 'asc',
			is_num: true
		});
	});
	$("#top-sort-list-1 .departure-h-2-l").click(function() {
		$(this).addClass('hide');
		$('#top-sort-list-1 .departure-l-2-h').removeClass('hide');
		$("#train_search_result #t-w-i-1").jSort({
			sort_by: '.t-d-t:first',
			item: '.r-r-i',
			order: 'desc',
			is_num: true
		});
	});
	//arrival sort
	$("#top-sort-list-1 .arrival-l-2-h").click(function() {
		$(this).addClass('hide');
		$('#top-sort-list-1 .arrival-h-2-l').removeClass('hide');
		$("#train_search_result #t-w-i-1").jSort({
			sort_by: '.t-a-t:first',
			item: '.r-r-i',
			order: 'asc',
			is_num: true
		});
	});
	$("#top-sort-list-1 .arrival-h-2-l").click(function() {
		$(this).addClass('hide');
		$('#top-sort-list-1 .arrival-l-2-h').removeClass('hide');
		$("#train_search_result #t-w-i-1").jSort({
			sort_by: '.t-a-t:first',
			item: '.r-r-i',
			order: 'desc',
			is_num: true
		});
	});
	//************************** SORTING END **********/

	/*  Mobile Filter  */
	$('.filter_tab').click(function() {
		$('.resultalls').stop( true, true ).toggleClass('open');
		$('.coleft').stop( true, true ).slideToggle(500);
	});
	
	var widowwidth = $(window).width();
	if(widowwidth < 991)
	{
		$('.resultalls.open .allresult').on('click',function() {
			$('.resultalls').removeClass('open');
			$('.coleft').slideUp(500);
		});
	}
	
	$('#j_quota').on('change', function() {
		loader();
		$('.j_class').removeClass('load-data');
		$('.f-a-d').addClass('hide');
	});
	
	//route details
	$(document).on('click', '.schedule-btn', function(e) {
		e.preventDefault();
		$.get(app_base_url+'index.php/ajax/train_schedule_details/'+_search_id+'?'+$.param($('.route-details', $(this).closest('.r-r-i')).serializeArray()), function(response) {
			if (response && response.status && response.status == true) {
				$('#train_schedule_model #schedule_body').html(response.data.body);
				$('#train_schedule_model #schedule_title').html(response.data.title);
				$('#train_schedule_model').modal();
			} else {
				console.log('Not Found');
			}
		});
	});
	
	//availability details
	$(document).on('click', '.j_class', function(e) {
		e.preventDefault();
		var current_row = $(this).closest('.r-r-i');
		var has_load = $(this).hasClass('load-data');
		$('.j_class', current_row).removeClass('load-data');
		$('.f-a-d', current_row).addClass('hide');
		var fare_avail = 'fare-availability-details-'+current_row.data('id');

		$(this).toggleClass('load-data');
		if (has_load == true) {
			$(this).removeClass('load-data');
			$('#'+fare_avail).html('').addClass('hide');
		} else {
			$(this).addClass('load-data');
			var j_class = $(this).data('value');
			var j_quota = $('#j_quota').val();
			var form = $('form.availability-details', current_row);
			$('[name="j_class"]', form).val(j_class);
			$('[name="j_quota"]', form).val(j_quota);
			$('#'+fare_avail).html('<div class="small-loader-gif"></div>').removeClass('hide');
			$.get(app_base_url+'index.php/ajax/train_fare_availability/'+_search_id+'?'+form.serialize(), function(response) {
				if (response && response.status && response.status == true) {
					$('#'+fare_avail).html(response.data.body);
				} else {
					$('#'+fare_avail).html(response.msg);
				}
			});
		}
	});

	//handle booking model
	var book_now_model = null;
	$(document).on('click', '.j_date_ts', function () {
		var form = $(this).closest('form');
		$('.j_date_ts', form).parent().removeClass('selected_class');
		if ($(this).is(":checked") && $(this).hasClass('selected_class') == false) {
			$(this).parent().addClass('selected_class');
			var current_row = $(this).closest('.r-r-i');
			var form = $('form.availability-details', current_row);
			$('[name="j_date_ts"]', form).val(this.value);
			
		}
	});
	
	$(document).on('click', '.book_now_train', function(e) {
		e.preventDefault();
		//check booking enabled
		var current_row = $(this).closest('.r-r-i');
		var journey_date_form = $('.journey-date-form', current_row);
		var journey = $('.j_date_ts:checked', journey_date_form);
		if (journey) {
			var book = $('.book', $(journey).closest('.j-date-wrap')).val();
			if (book && book == true) {
				var form = $('form.availability-details', current_row).submit();
				return '';
			}
		}
		alert('Booking Can Not Be Made For Selected Journey Date!!!');
	});
});