var inlineStylesApplied = false;
$("#btnExport").click(function(e) {
	//apply inline styles to table 
  if(!inlineStylesApplied){
 	  $('#flight_table').inlineStyler();
    inlineStylesApplied = true;
  }
  exportToCsv($('#flight_table'), 'newfile.csv');
  e.preventDefault();
});

function exportToCsv($table, filename) {
  var csv = $table.table2CSV();
  var csvData;
  console.log(csv);
  //Save file
  if (msieversion()) {
    csvData = decodeURIComponent(csv);
    if (window.navigator.msSaveBlob) {
      var blob = new Blob([csvData], {
        type: "application/csv;charset=utf-8;"
      });
      navigator.msSaveBlob(blob, filename);
    }
  } else {
    csvData = "data:text/csv;charset=utf-8," + encodeURIComponent(csv);
   // window.open(csvData);
   // $(this).attr({
   //   "href": csvData,
   //   "target": "_blank",
  //    "download": filename
  //  });
  }
  var link = document.createElement("a");
  link.setAttribute("href", csvData);
  link.setAttribute("download", filename);
  link.click(); // This will download the data file named "my_data.csv".
}
function msieversion() {
  var ua = window.navigator.userAgent;
  var msie = ua.indexOf("MSIE ");
  if (msie > 0 || !!navigator.userAgent.match(/Trident.*rv\:11\./)){
    return parseInt(ua.substring(msie + 5, ua.indexOf(".", msie)));
  }
  return false;
}

(function($) {
	$.fn.inlineStyler = function(options) {
		var settings = $.extend({
			// These are the defaults.
			// taken from http://templates.mailchimp.com/resources/email-client-css-support
			'propertyGroups' : {
				'*' : ['border', 'border-radius', 'box-shadow', 'height', 'margin', 'padding', 'width', 'max-width', 'min-width', 'border-collapse', 'border-spacing', 'caption-side', 'empty-cells', 'table-layout', 'direction', 'font', 'font-family', 'font-style', 'font-variant', 'font-size', 'font-weight', 'letter-spacing', 'line-height', 'text-align', 'text-decoration', 'text-indent', 'text-overflow', 'text-shadow', 'text-transform', 'white-space', 'word-spacing', 'word-wrap', 'vertical-align', 'color', 'background', 'background-color', 'background-image', 'background-position', 'background-repeat', 'Opacity', 'bottom', 'clear', 'clip', 'cursor', 'display', 'float', 'left', 'opacity', 'outline ', 'overflow', 'position', 'resize ', 'right', 'top', 'visibility', 'z-index', 'list-style-image', 'list-style-position', 'list-style-type'],
				'block' : ['margin', 'padding']
			},
			// taken from http://www.w3schools.com/tags/default.asp
			'elementGroups' : {
				'*' : ['A', 'ABBR', 'ACRONYM', 'ADDRESS', 'APPLET', 'AREA', 'ARTICLE', 'ASIDE', 'AUDIO', 'B', 'BASE', 'BASEFONT', 'BDI', 'BDO', 'BIG', 'BLOCKQUOTE', 'BODY', 'BR', 'BUTTON', 'CANVAS', 'CAPTION', 'CENTER', 'CITE', 'CODE', 'COL', 'COLGROUP', 'COMMAND', 'DATALIST', 'DD', 'DEL', 'DETAILS', 'DFN', 'DIALOG', 'DIR', 'DIV', 'DL', 'DT', 'EM', 'EMBED', 'FIELDSET', 'FIGCAPTION', 'FIGURE', 'FONT', 'FOOTER', 'FORM', 'FRAME', 'FRAMESET', 'H1', 'HEAD', 'HEADER', 'HR', 'HTML', 'I', 'IFRAME', 'IMG', 'INPUT', 'INS', 'KBD', 'KEYGEN', 'LABEL', 'LEGEND', 'LI', 'LINK', 'MAP', 'MARK', 'MENU', 'META', 'METER', 'NAV', 'NOFRAMES', 'NOSCRIPT', 'OBJECT', 'OL', 'OPTGROUP', 'OPTION', 'OUTPUT', 'P', 'PARAM', 'PRE', 'PROGRESS', 'Q', 'RP', 'RT', 'RUBY', 'S', 'SAMP', 'SCRIPT', 'SECTION', 'SELECT', 'SMALL', 'SOURCE', 'SPAN', 'STRIKE', 'STRONG', 'STYLE', 'SUB', 'SUMMARY', 'SUP', 'TABLE', 'TBODY', 'TD', 'TEXTAREA', 'TFOOT', 'TH', 'THEAD', 'TIME', 'TITLE', 'TR', 'TRACK', 'TT', 'U', 'UL', 'VAR', 'VIDEO', 'WBR']
			}
		}, options );
		this.each(function(index, value) {
			for(var group in settings.elementGroups) { 
				for(var i=0, len=settings.elementGroups[group].length; i<len; i++) {
					// search for all these tags
					var elements = $(this).find(settings.elementGroups[group][i]);
					elements.each(function(){
						// get the current style rules
						if($(this).attr('style')){
							var styles = $(this).attr('style');
							var properties = styles.split(';');
						} else {
							var properties = [];
						}
						// find all the properties in this rule group
						for(var i=0, len=settings.propertyGroups[group].length; i<len; i++) {
							var thisProp = settings.propertyGroups[group][i];
							if($(this).css(thisProp)) {
								properties.push(thisProp + ':' + $(this).css(thisProp));
							}
						}
						// add them onto the element as an inline style rule
						$(this).attr('style', properties.join(';'));
					});
				}
			}
		});
	};
}( jQuery ));

jQuery.fn.table2CSV = function(options) {
  var options = jQuery.extend({
      separator: ',',
      header: [],
      delivery: '' // popup, value
    },
    options);
  var csvData = [];
  var headerArr = [];
  var el = this;
  //header
  var numCols = options.header.length;
  var tmpRow = []; // construct header avalible array
  if (numCols > 0) {
    for (var i = 0; i < numCols; i++) {
      tmpRow[tmpRow.length] = formatData(options.header[i]);
    }
  } else {
    $(el).filter(':visible').find('th').each(function() {
      if ($(this).css('display') != 'none') tmpRow[tmpRow.length] = formatData($(this).html());
    });
  }
  row2CSV(tmpRow);
  // actual data
  $(el).find('tr').each(function() {
    var tmpRow = [];
    $(this).filter(':visible').find('td').each(function() {
      if ($(this).css('display') != 'none') tmpRow[tmpRow.length] = formatData($(this).html());
    });
    row2CSV(tmpRow);
  });
  if (options.delivery == 'popup') {
    var mydata = csvData.join('\n');
    return popup(mydata);
  } else {
    var mydata = csvData.join('\n');
    return mydata;
  }
  function row2CSV(tmpRow) {
    var tmp = tmpRow.join('') // to remove any blank rows
      // alert(tmp);
    if (tmpRow.length > 0 && tmp != '') {
      var mystr = tmpRow.join(options.separator);
      csvData[csvData.length] = mystr;
    }
  }
  function formatData(input) {
    // replace " with â€œ
    var regexp = new RegExp(/["]/g);
    var output = input.replace(regexp, "â€œ");
    //HTML
    var regexp = new RegExp(/\<[^\<]+\>/g);
    var output = output.replace(regexp, "");
    if (output == "") return '';
    return '"' + output + '"';
  }
  function popup(data) {
    var generator = window.open('', 'csv', 'height=400,width=600');
    generator.document.write('<html><head><title>CSV</title>');
    generator.document.write('</head><body >');
    generator.document.write('<textArea cols=70 rows=15 wrap="off" >');
    generator.document.write(data);
    generator.document.write('</textArea>');
    generator.document.write('</body></html>');
    generator.document.close();
    return true;
  }
};